#!/usr/bin/perl
#
#  Informationen zu Billig-Vorwahlen auslesen
#  aus Seite www.billiger-telefonieren.de
#
#  R. Unger 11/2002
#  modif. M. S. 11/2004
#  

use strict;
use LWP::Simple; 

########## Holen der Seite http://www.billiger-telefonieren.de/tarife/schnellrechner.php3?tag=heute&sekundengenau=240&zone=Fern&stunde=jetzt&anmeldung=&grundgebuehr=&zugang=&limit=25&order=preis,takt_a ##########
#####################################################################

my $url="http://www.billiger-telefonieren.de/tarife/schnellrechner.php3?tag=heute&sekundengenau=240&zone=Fern&stunde=jetzt&anmeldung=&grundgebuehr=&zugang=&limit=25&order=preis,takt_a";
my @datalines;
my $sec;
my $min;
my $hour;
my $mday;
my $mon;
my $year;
my $wday;
my $yday;
my $isdst;
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
$year=$year+1900;
$mon=$mon+1;

print "Holen der Vorwahl-Infos von www.billiger-telefonieren.de\n";
my $doc = get($url);               # Hole die URL.


                          	#  Benutzung eines Hash
my %tabVorwahlen=(        	#  - %.. ist der Identifizier
"1."    => "UNDEFINED",     	#  - wird ber Zeichenketten statt ber natrliche Zahlen induziert
"2."  => "UNDEFINED",     	#  - Schlssel => Wert
"3."    => "UNDEFINED",     
"4."  => "UNDEFINED",     
"5."=> "UNDEFINED"
);

@datalines = split (/\n/,$doc); 

#------------------------------------------------------------------------------------------------
########## Parsen der Kosten / Vorwahlen / Anbieter #######
###########################################################

my $tabPosKorrektur=0;

sub parse_it                       # beginnen zu parsen
{
   my $tabPos=shift;                  # fgt der Variable $uni das 1. Element von parse_it()
   my $toparse=shift;   # fgt der Variable $uni das 2. Element von parse_it()                              

   #print "Parsen begonnen ...\n";  

   my $n=0;
   my $tabPosSuche=$tabPos+$tabPosKorrektur;
   #print "tabPosSuche: $tabPosSuche\ttabPosKorrektur: $tabPosKorrektur\n";
   foreach my $line (@datalines)  
    {
    # if ($line =~ /border=\"0\"> $toparse<\/a><\/td>\s*$/  ) # Zeile wird gesucht in der unsere
                                                              # interessierende Information steht
    if ($line =~ "class='fbrb'>$tabPosSuche\.</td>")                                                             
      {
      #print "Vorwahl $tabPos in Zeile $n ...\n";             # in welcher Zeile wurde diese Info gefunden

     
      my $kosten=$datalines[$n+2];
      $kosten =~ /.*>(.+,.+)&.*/;                             #  ^ ... Suche am Anfang der Zeile 
      $kosten = $1;
      #$kosten = $1;                                          #  $ ... Suche am Ende der Zeile 
      #$kosten =~ s/\.//; 

     
      my $vorwahl=$datalines[$n+4];
      $vorwahl =~ /.class='*fbbb'>(\d*)/;
      $vorwahl = $1;
      #$vorwahl =~ s/<[\/\w\s]+>\s+$//i;
      
      my $anbieter=$datalines[$n+5];
      #print "$anbieter\n";
      #$anbieter =~ /.*anbieter\.php3\?name=(\w*\d*)'.*/;
      $anbieter =~ /.*class='fbbbu' style='text-decoration: underline'>(\w+\s?\w+)/;
      $anbieter = $1;
      
      my $takt=$datalines[$n+5];
      $takt =~ /(\d+\/\d+)<\/td>$/;
      $takt = $1;
	
      if ($kosten=~/0,00/) 	# Falls die Kosten "0,00" betragen -> rauswerfen da Preselection
      				# Mu eventuell noch verbessert -> generelles rauswerfen von Preselection (oder andere Webadresse?)
	      {
	      	$tabPosKorrektur++;
	      	parse_it("$tabPos","");
	      }		
      else
	      {		   
	      	print "Nr $tabPos: $kosten Cent/Min\tVorwahl: $vorwahl\tTakt: $takt\tAnbieter: $anbieter\n";     # Ausgabe der gefundenen Werte
	      	$tabVorwahlen{$tabPos}="$kosten :: $vorwahl";
	      
	     
	     	chomp $tabPos;
	     	chomp $vorwahl;
	     
		#print "Daten sichern in Datei vorwahlen.txt\n\n";
		
		open (REIN, ">>vorwahlen.txt");                           # Anlegen der Datei und einfgen
		                                               		  # der geordneten geparsten Daten
		if ( $tabPos =~ "1") {printf REIN ("%04i-%02i-%02i  %02i:%02i.%02i\n",$year,$mon,$mday,$hour,$min,$sec);}
		#if ( $d !~ /[\d*.\d*]+/ )  {$d = "-1";}                
		print REIN "$kosten\t$vorwahl\t$takt\t$anbieter\n";
		close (REIN);
		
		#last;
	      }
      }      
   
   $n++;
  }
} # sub parse_it
#------------------------------------------------------------------------------------------------

parse_it("1","");                           # Aufrufen der Subroutine parse_it
parse_it("2","");                       
parse_it("3","");                       
parse_it("4","");
parse_it("5",""); 
parse_it("6","");                     
parse_it("7","");
parse_it("8",""); 


print "Billig-Vorwahlen ausgelesen\n";
exit;
#my $x=<STDIN>;


